/*
 * graph.h
 * Copyright (C) 1994 by candy
 * $Id: graph.h,v 1.2 1994/10/26 04:21:34 candy Exp candy $
 */
#ifndef GRAPH_H /* [ */
#define GRAPH_H

extern int graph_init_done;
extern Widget graph_widget;
extern Pixmap graph_pix;
extern GC graph_gc;
extern GC graph_bg;
extern unsigned int graph_width;
extern unsigned int graph_height;

extern int graph_npalet;
extern unsigned long *graph_pixels; /* graph_pixels[graph_npalet] */
extern XColor *graph_colors;

void graph_get_graph_size(Widget w, long *x, long *y);
void graph_line(Widget w, int x0, int y0, int x1, int y1, int pal);
void graph_box_fill(Widget w, int x0, int y0, int x1, int y1, int pal);
void graph_circle(Widget w, int x0, int y0, int r, int pal);
void graph_clear(Widget w);
void graph_set_a_palet(Widget w, int pal, int red, int green, int blue);
void graph_set_palet(Widget w, XColor *cp);
void graph_rotate_palet(Widget w, int start, unsigned int n, int dir, int idx, int red, int green, int blue);
void graph_alloc_palet(Widget w, int npalet, unsigned long bg, unsigned long fg);
void graph_init_once(Widget w);
void graph_create_proc(Widget w, XEvent *e, String *para, Cardinal *cp);
void graph_map_proc(Widget w, XEvent *e, String *para, Cardinal *cp);
void graph_config_proc(Widget w, XEvent *e, String *para, Cardinal *cp);
void graph_expose_proc(Widget w, XEvent *e, String *para, Cardinal *cp);
int end_graph(void);

#define get_graph_size(x,y) graph_get_graph_size(graph_widget,x,y)
#define set_a_palet(p,r,g,b) graph_set_a_palet(graph_widget,p,r,g,b)
#define set_palet(cp) graph_set_palet(graph_widget,cp)
#define rotate_palet(start,n,dir,idx,red,green,blue) graph_rotate_palet(graph_widget,start,n,dir,idx,red,green,blue)
#define line(x0,y0,x1,y1,pal) graph_line(graph_widget,x0,y0,x1,y1,pal)
#define box_fill(x0,y0,x1,y1,pal) graph_box_fill(graph_widget,x0,y0,x1,y1,pal)
#define circle(x0,y0,r,pal) graph_circle(graph_widget,x0,y0,r,pal)
#define clear() graph_clear(graph_widget)


#endif /* ] */
