/*
 * gru.c - grugru
 * Copyright (C) 1993, 1994 by ?????/candy
 */
static char rcsid[] = "$Id: gru.c,v 1.2 1994/10/26 04:28:41 candy Exp candy $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Paned.h>

#include "graph.h"

#define SUCCESS 0
#define ERROR (-1)

#define NPALET 15


int pause_time;

char *myname;

static long cur_x, cur_y;

static void
make_pattern(void)
{
	int i;
	long r, rmax;
	long ox, oy;
	get_graph_size(&cur_x, &cur_y);
	ox = cur_x / 2;
	oy = cur_y / 2;
	clear();
	rmax = sqrt(ox * ox + oy * oy);
#define zcircle(x0,y0,r,p) circle((x0)+ox,oy-(y0),(r),(p))
	for (i = 0; (r = i * 2 / 2) < rmax; i++) {
		int p;
		if (((r / 100) % 2) == 0) {
			p = NPALET - 1 - (i % NPALET);
			if (p == 0)
				p = NPALET;
		}
		else {
			p = (i % NPALET) + 1;
		}
		zcircle(0, 0, r, p);
	}/* for */
}/* make_pattern */

static void
update_pattern(void)
{
	long wx, wy;
	get_graph_size(&wx, &wy);
	if (wx != cur_x || wy != cur_y) {
		make_pattern();
	}
}/* update_pattern */

static void
make_palet(void)
{
	int i;
	for (i = 0; i < NPALET / 3; i++) {
		set_a_palet(i, 0xffff, 0xffff, 0xffff);
	}
	for (i = NPALET / 3; i < NPALET; i++) {
		set_a_palet(i, 0, 0, 0);
	}
}/* make_palet */

static void
do_gru(void)
{
	rotate_palet(1, NPALET, 1, -1, 0, 0, 0);
}/* do_gru */

static void
quit_command_proc(Widget w, XtPointer p1, XtPointer p2)
{
	exit(1);
}/* quit_command_proc */

static void
timeout_proc(XtPointer p1, XtIntervalId* id)
{
	XtAppContext app_con = p1;
	if (graph_init_done) {
		do_gru();
	}
	XtAppAddTimeOut(app_con, pause_time, timeout_proc, app_con);
}/* timeout_proc  */

static void
any_proc(Widget w, XEvent *e, String *para, Cardinal *cp)
{
}/* any_proc */

static void
gru_graph_config_proc(Widget w, XEvent *e, String *para, Cardinal *cp)
{
	graph_config_proc(w, e, para, cp);
	update_pattern();
	make_palet();
}/* gru_graph_config_proc */



int
main(int argc, char *argv[])
{
	static String fallback_resources[] = {
		"*graph.translations: #override \\n" /* no comma */
		" <Create>: graph_create_proc() \\n" /* no comma */
		" <Map>: graph_map_proc() \\n" /* no comma */
		" <Expose>: graph_expose_proc() \\n" /* no comma */
#ifdef GRU_RESIZE
		" <Configure>: graph_config_proc() \\n" /* no comma */
#else
		" <Configure>: gru_graph_config_proc() \\n" /* no comma */
#endif
		"",
		"*graph*showGrip: off",
		"*graph*resizeToPreferred: yes",
		"*graph.background: black",
		"*graph.fromVert: quit",
		"*graph.width: 640",
		"*graph.height: 480",
		NULL
	};
	static XtActionsRec actions[] = {
		{"graph_create_proc", graph_create_proc},
		{"graph_map_proc", graph_map_proc},
		{"graph_expose_proc", graph_expose_proc},
#ifdef GRU_RESIZE
		{"graph_config_proc", graph_config_proc},
#else
		{"gru_graph_config_proc", gru_graph_config_proc},
#endif
		{"any_proc", any_proc},
	};
	/*
	 * option
	 */
	struct app_resources_t {
		int length;
		int count;
		int wait;
		int maxspeed;
		int random;
		int cspeed;
	};
	static struct app_resources_t app_resources;
#define DEFINT(member,name,val) {#member, name, XtRInt, sizeof(int), XtOffset(struct app_resources_t *, member), XtRImmediate, (XtPointer)(val)}
	static XtResource resources[] = {
		DEFINT(wait, "Wait", 17),
	};
	static XrmOptionDescRec options[] = {
		{"-wait", ".Wait", XrmoptionSepArg, NULL},
	};
	XtAppContext app_con;
	Widget toplevel = XtVaAppInitialize(&app_con, "Grugru", options, XtNumber(options), &argc, argv, fallback_resources, NULL);
	Widget graph, form = XtVaCreateManagedWidget("paned", panedWidgetClass, toplevel, NULL);
	XtVaGetApplicationResources(toplevel, (caddr_t)&app_resources, resources, XtNumber(resources), NULL);
	XawDialogAddButton(form, "quit", quit_command_proc, NULL);
	pause_time = app_resources.wait;
	XtAppAddActions(app_con, actions, XtNumber(actions));
	graph = XtVaCreateManagedWidget("graph", widgetClass, form, NULL);
	XtRealizeWidget(toplevel);
	graph_init_once(graph);
	XtAppAddTimeOut(app_con, pause_time, timeout_proc, app_con);
	XtAppMainLoop(app_con);
	return 0;
}/* main */
